var thumbSize = [% IF thumbSize %][% thumbSize %][% ELSE %]130[% END %];
var thumbHrefTemplate = '/music/COVER/thumb_'+thumbSize+'x'+thumbSize+'_p.jpg';

[% PROCESS html/global.js %]

var statusstub = webroot + statusroot + '?';


function globalOnload() {
//	refreshLibraryInfo();
	window.onscroll = hideBrowserBar;
	window.scrollBy (0,1);
}

function hideBrowserBar() {
		if (!window.pageYOffset) 
			window.scrollTo (0, 1);
 }

function chooseAlbumOrderBy(value, option, artwork)
{
	if (!artwork && artwork != 0) {
		artwork = 1;
	}
        var url = '[% webroot %]browsedb.html?hierarchy=[% hierarchy %]&level=[% level %][% attributes %][% IF artwork OR artwork == '0' %]&artwork='+artwork+'[% END %]&player=[% playerURI %]'; 
        if (option) {
                url = url + '&orderBy=' + option;
        }
        setCookie( 'SqueezeCenter-orderBy', option );
        window.location = url;
}

function setAlbumOrderBy(value, option)
{
    setCookie( 'SqueezeCenter-orderBy', option );
}


function setCookie(name, value) {
        var expires = new Date();
        expires.setTime(expires.getTime() + 1000*60*60*24*365);
        document.cookie =
                name + "=" + escape(value) +
                ((expires == null) ? "" : ("; expires=" + expires.toGMTString()));
}

function getCookie(param){
	var c = document.cookie + ";";
	var re = /\s?(.*?)=(.*?);/g;
	var matches;
	while((matches = re.exec(c)) != null){
		var name = matches[1];
		var value = matches[2];
		if (name == param) {
			return unescape(value);
		}
	}
	return '';
}


// enters message sent to OSD div (typically still needs to be made visible with a different function)
function changeOSD(message) {
	if ($('OSD')) {
		$('OSD').innerHTML = message;
	}
}

// send a message and number of milliseconds duration to the OSD div
function showVolumeOSD(message, duration) {
	var msDuration = parseInt(duration, 10);

	if ($('volumeOSD')) {
		$('volumeOSD').innerHTML = '';
		$('volumeOSD').style.display = 'block';
		$('volumeOSD').innerHTML = message;
	}

	var intervalID = setTimeout(hideVolumeOSD, msDuration);
}

function hideVolumeOSD() {

	if ($('volumeOSD')) {
		$('volumeOSD').style.display = 'none';
	}

}

function showAdded() {

	if ($('OSDbg')) {
	 	$('OSDbg').style.top = window.pageYOffset + 140;
		$('OSDbg').style.display = 'block';
	}
	if ($('OSD')) {
	 	$('OSD').style.top = window.pageYOffset + 140;
		$('OSD').style.display = 'block';
	}

	var intervalID = setTimeout("hideAdded()", 2000);
}

function hideAdded() {

	if ($('OSD')) {
		$('OSD').style.display = 'none';
	}
	if ($('OSDbg')) {
		$('OSDbg').style.display = 'none';
	}
}

function resize(src,width) {
	if (!width) {
		// special case for IE (argh)
		if (document.all) {
			width = document.body.clientWidth*0.5;
		} else if (document.getElementById) { //else if NS6+ 
			width = window.innerWidth*0.5;
		}
	}
	if (src.width > width ) {
		src.width = width;
	}
}

function toggleGalleryView(artwork) {
	var thisdoc = document;
	if (thisdoc.location.pathname != '') {
		myString = new String(thisdoc.location.href);
		if (artwork) {
			setCookie( 'SqueezeCenter-albumView', "1" );
			if (thisdoc.location.href.indexOf('start') == -1) {
				thisdoc.location=thisdoc.location.href+"&artwork=1";
			} else {
				myString = new String(thisdoc.location.href);
				var rExp = /\&start=/gi;
				thisdoc.location=myString.replace(rExp, "&artwork=1&start=");
			}
		} else {
			setCookie( 'SqueezeCenter-albumView', "" );
			var rExp = /\&artwork=1/gi;
			thisdoc.location=myString.replace(rExp, "");
		}
	}
}


function storeReturnLevel() {
 	var hreftmp = new String (document.location);
	var myString = '';
	var idxTemp = hreftmp.indexOf("hierarchy=");
	var hierarchy = null;
	var level = '0';
	if (idxTemp == -1) {
	 	return;
	}
	hierarchy = hreftmp.slice (idxTemp + 10); // LO("&hierarchy=")
 	idxTemp = hierarchy.indexOf ('&');
 	if (idxTemp > 0)
 		hierarchy = hierarchy.substr(0, idxTemp);
 	hierarchy = escape(hierarchy);
 	
 	idxTemp = hreftmp.indexOf("level=");
 	if (idxTemp != -1) {
		level = hreftmp.slice (idxTemp + 6); // LO ("&level=")
		idxTemp = level.indexOf ('&');
		if (idxTemp > 0)
			level = level.substr(0, idxTemp);
	}
 		
 	idxTemp = hreftmp.indexOf('start=');
	if (idxTemp != -1) {
	 	myString = hreftmp.slice (idxTemp + 6); // LO ("&start=")
	 	idxTemp = myString.indexOf ('&');
	 	if (idxTemp > 0)
	 		myString = myString.substr(0,idxTemp);
	}
	setCookie( 'SqueezeCenter-returnToH' + hierarchy + level, myString );
}

function returnToLevel(hRefParam) {
	var rExp = /\&href=/gi;			// hack to get rid of "href="
 	var param = hRefParam.replace(rExp, "");
 
	var idxTemp = param.indexOf('hierarchy=');
	if (idxTemp == -1) {
	 	document.location = param;
	 	return;		
	}
	var hierarchy = param.slice (idxTemp + 10); //LO ("&h...")
 	idxTemp = hierarchy.indexOf ('&');
 	if (idxTemp > 0)
 		hierarchy = hierarchy.substr(0, idxTemp);
 	hierarchy = escape(hierarchy);

	var level = '0';
 	idxTemp = param.indexOf('level=');
 	if (idxTemp != -1) {
		level = param.slice (idxTemp + 6);
		idxTemp = level.indexOf ('&');
		if (idxTemp > 0)
			level = level.substr(0, idxTemp);
	}
	document.location = param + "&start=" + getCookie( 'SqueezeCenter-returnToH' + hierarchy + level );
}

function storeReturnPage() {
 	var hreftmp = new String (document.location);
	setCookie( 'SqueezeCenter-returnToView', hreftmp );
}

function returnToViewPage() {
	var thisdoc = window;
	var myString = new String ( getCookie( 'SqueezeCenter-returnToView' ) );
	if (myString) {
		document.location = myString;
	}
}


function powerControl (action) {
	var args = "p0=power&p1=" + parseInt(action) + "&player=" + player + "&ajaxRequest=1";
	// always use status.html for this request
	var old_url = url;
	if (action) {
		Element.hide("powerControlOff");
		document.getElementById("powerControlOn").style.display = "block";
//		Element.show("powerControlOff");
		} else {
		Element.hide("powerControlOn");
		document.getElementById("powerControlOff").style.display = "block";
//		Element.show("miniControlPlay");
	}
	url = webroot + 'status.html';
	getStatusData(args, refreshNothing);
	url = old_url;
}


// miniControls is for putting play/pause on any page. ajax request is made via status.html
function miniControls(action) {
	var args = "p0=" + action + "&player=" + player + "&ajaxRequest=1";

	// always use status.html for this request
	var old_url = url;

	if (action == 'play') {
		Element.hide("miniControlPlay");
		document.getElementById("miniControlPause").style.display = "block";
//		Element.show("miniControlPause");
		} else {
		Element.hide("miniControlPause");
		document.getElementById("miniControlPlay").style.display = "block";
//		Element.show("miniControlPlay");
	}
	url = webroot + 'status.html';
	getStatusData(args, refreshNothing);
	url = old_url;
}


function callJSONRPC(paramArray, callback, failure) {
	var temp = {
	 		"id" : 1,
			"method" : "slim.request",
			"params" : [ playerid, paramArray ]};
//alert ("cJR:" + paramArray + '.:.' + callback + '.:.' + failure);
	new Ajax.Request ('/jsonrpc.js', {
	 		 method: 'post',
	 		 postBody: Object.toJSON(temp),
	 		 onSuccess: function (transport) {
				var response = transport.responseText.evalJSON(true);
//alert("rt:" +transport.responseText + ".:." + response);
				callback (response); },
			 onFailure: function (response) { 
			  	if (failure) failure(response); } });
}


function addItem(args) {
	getStatusData(args, showAdded);
}

function goToStatus(goStatus) {
	if (goStatus)
		document.location = statusstub + 'player=' + player;
}

function addPlayItem(args) {
// alert ("a:" + args);
//	var rExp = /\&ajaxRequest=1/gi;
//	var param = args.replace(rExp, "");
//alert ("api:" + args);
	var	param = unescape(args);
	var rExp = /\&\&+/gi;
	param = param.replace(rExp, "&");
// alert ("p:" + param);
 	var paramArray = param.split("&");
//alert ("pA:" + paramArray);
	callJSONRPC (paramArray, function (res) { goToStatus(true); });
}

function clearCurrentPlaylist() {
	if (confirm("Do You really want to clear the current playlist?")) {
		var sArray = [ 'playlist', 'clear' ];
		callJSONRPC(sArray, function (r2) { hidePlaylistControl(); }, function (r2) {});
	}
}

function showPlaylistControl() {
	if ($('currentPlaylistControl'))
		Element.show('currentPlaylistControl');
}

function hidePlaylistControl() {
	if ($('currentPlaylistControl'))
		Element.hide('currentPlaylistControl');
}
